#!perl vdiff.pl
# usage: perl vdiff.pl original_file modified_file > outfile
# copyright (C) 1996-2000 Jun TAKASHIMA (tjun@aa.tufs.ac.jp)
# version 1.0 2000/03/30
#############################################################
# This is a diff tool for verse numbered e-texts.
# The two texts must have the same form like:
# -------------------------------------------------------------------
# tantraloka.1.2b/. maatRmaanaprameyaaMzazuulaambujakRtaaspadaam // 2
# -------------------------------------------------------------------
# title name with verse number and the verse itself separated by ``/.''
# It compares the contents of the same verse number, and if different
# it will output the two contents.
# It will ignore lines which do not contain ``/.''
# It does not work correctly if the number part are different.
# patch.pl is available to incert changes from the diff file.
#######################################################################
# -----------below Japanese explanation -----------------------
# vdiff.pl - tB[h̃R[ȟ㔼قȂĂ̂o͂
# ̓t@Č`:   /. 
# ܂Aꎍߔԍ̖{݂̂قȂĂꍇ̍Ƃ邽߂ɎgpB
# ߔԍSɑΉĂȂƐmɓ삵Ȃ
# ̐lɍZĂĂeLXgf[^x[X̃eiX
# ̂߂̃c[łB
# usage: jperl vdiff.pl infile1 infile2 > outfile
# infiles ̂Ȃ /. ܂܂Ȃs͖B
#-----------------------------------------------------------------
{
	 $orig_file = $ARGV[0];
	 $comp_file = $ARGV[1];
	 if (!open(orig_file,"<$orig_file")) { 
		die "cannot access orig_file \`$orig_file\'\n"; 
	 }
	 if (!open(comp_file,"<$comp_file")) { 
		die "cannot access comp_file \`$comp_file\'\n"; 
	 }
	 $tm_start = time;
}
oline: while (<orig_file>) {
	$n_rec++;
	if (!($n_rec % 1000)) { 
		$tm_used= time - $tm_start;
		print STDERR "$n_rec lines, $c_count lines compared, $tm_used sec...\n";
	}
	unless (/\/\./){next oline;}
	($onum,$ocontent) = split(/\/\./, $_ ,2);
	$orig_v++;
	line: while (<comp_file>) {
		unless (/\/\./){next line;}
		($num,$content) = split(/\/\./, $_ ,2);
		$comp_v++;
		if ($num eq $onum){
			if ($content eq $ocontent){next oline;}
			else {
				print "orig= ", $onum, "/.", $ocontent;
				print "new = ", $num, "/.", $content, "\n";
				$c_count++;
				next oline;
			}
		}
		else {
			print STDERR "unmatched verse in line $. \n";
		}
	}
}
{
	close(orig_file);
	close(comp_file);
	print "\n total number of lines differenciated is ", $c_count, "\n";
	$tm_used= time - $tm_start;
	print STDERR "$n_rec lines, $tm_used sec\n";
	unless ($orig_v == $comp_v){
		print STDERR "original file contains $orig_v half verses\n";
		print STDERR "while compared file contains $comp_v half verses\n";
	}
}
